#pragma once

namespace ActiveBasic{ namespace Common{ namespace Lexical{


class NamespaceSupporter
{
	const NamespaceScopesCollection *allNamespaceScopesCollection;

	// ImportsꂽO
	NamespaceScopesCollection importedNamespaces;

	// ݂̖O
	NamespaceScopes livingNamespaceScopes;

public:
	NamespaceSupporter()
		: allNamespaceScopesCollection( NULL )
	{
	}

	void RegistAllNamespaceScopesCollection( const NamespaceScopesCollection *allNamespaceScopesCollection )
	{
		this->allNamespaceScopesCollection = allNamespaceScopesCollection;
	}

	const NamespaceScopesCollection &GetImportedNamespaces()
	{
		return importedNamespaces;
	}
	void SetImportedNamespaces( const NamespaceScopesCollection &namespaces )
	{
		this->importedNamespaces = namespaces;
	}
	void ClearImportedNamespaces()
	{
		this->importedNamespaces.clear();
	}
	bool ImportsNamespace( const NamespaceScopes &namespaceScopes );
	bool ImportsNamespace( const std::string &namespaceStr );

	NamespaceScopes &GetLivingNamespaceScopes()
	{
		return livingNamespaceScopes;
	}
	void SetLivingNamespaceScopes( const NamespaceScopes &namespaceScopes )
	{
		this->livingNamespaceScopes = namespaceScopes;
	}
	bool IsLiving( const NamespaceScopes &namespaceScopes ) const
	{
		return NamespaceScopes::IsBelong( namespaceScopes, livingNamespaceScopes );
	}


	// Ă邩`FbN
	// :
	// this =   "Discoversoft.ActiveBasic"
	// living = "Discoversoft.ActiveBasic"
	// entryName =   "ActiveBasic"
	// ̏ꍇAliving  entryName ĂB
	bool IsCoverd( const NamespaceScopes &namespaceScopes, const std::string &entryName ) const
	{
		if( namespaceScopes.IsEqual( entryName ) )
		{
			return true;
		}

		std::string thisStr = namespaceScopes.ToString();

		NamespaceScopes tempLivingNamespaceScopes = livingNamespaceScopes;

		while( tempLivingNamespaceScopes.size() )
		{
			std::string tempStr = tempLivingNamespaceScopes.ToString() + "." + entryName;
			if( thisStr == tempStr )
			{
				return true;
			}

			tempLivingNamespaceScopes.pop_back();
		}
		return false;
	}
	bool IsCoverd( const NamespaceScopes &baseNamespaceScopes, const NamespaceScopes &entryNamespaceScopes ) const
	{
		return IsCoverd( baseNamespaceScopes, entryNamespaceScopes.ToString() );
	}


	// w肳ꂽOԂGAƌȂ邩ǂ`FbN
	bool IsSameAreaNamespace( const NamespaceScopes &baseNamespaceScopes, const NamespaceScopes &entryNamespaceScopes ) const;
};


}}}
